Name: brltty
Version: 3.5
Release: 1

Group: System Environment/Daemons
License: GPL
Vendor: The BRLTTY Team
Packager: Dave Mielke <dave@mielke.cc>
URL: http://mielke.cc/brltty/
Source: http://mielke.cc/brltty/releases/%{name}-%{version}.tar.gz

BuildRequires: autoconf >= 2.53
BuildRequires: make
BuildRequires: gcc
BuildRequires: /bin/sh
BuildRequires: /bin/ln
BuildRequires: /usr/bin/ld
BuildRequires: /sbin/ldconfig
BuildRequires: /usr/bin/ranlib
BuildRequires: /usr/bin/ar
BuildRequires: /usr/bin/awk
BuildRequires: /usr/bin/bison
BuildRequires: /usr/bin/install
BuildRequires: glibc-devel

BuildRoot: %{_tmppath}/%{name}-%{version}-InstallRoot
%define _bindir /bin
%define _sbindir /sbin
%define _libdir /lib
%define _sysconfdir /etc

AutoProv: 1

AutoReq: 1
Requires: /bin/sh

Summary: Braille display driver for Linux/Unix.
%description
BRLTTY is a background process (daemon) which provides access to the
Linux/Unix console (when in text mode) for a blind person using a
refreshable braille display.  It drives the braille display, and
provides complete screen review functionality.  Some speech capability
has also been incorporated.

Install this package if you use a refreshable braille display.

%package -n brlapi
Version: 0.2.0
Group: Applications/System

AutoProv: 1

AutoReq: 1

Summary: Appliation Programming Interface for BRLTTY.
%description -n brlapi
This package provides the run-time support for the Application
Programming Interface to BRLTTY.

Install this package if you have an application which directly accesses
a refreshable braille display.

%package -n brlapi-devel
Version: 0.2.0
Group: Development/System

AutoProv: 1

AutoReq: 1
Requires: brlapi = 0.2.0

Summary: Headers, static archive, and documentation for BrlAPI.
%description -n brlapi-devel
This package provides the header files, static archive, shared object
linker reference, and reference documentation for BrlAPI (the
Application Programming Interface to BRLTTY).  It enables the
implementation of applications which take direct advantage of a
refreshable braille display in order to present information in ways
which are more appropriate for blind users and/or to provide user
interfaces which are more specifically atuned to their needs.

Install this package if you're developing or maintaining an application
which directly accesses a refreshable braille display.

%prep
# %setup -n %{name}-%{version}
%setup -n brltty-3.5

%build
%configure --with-install-root="${RPM_BUILD_ROOT}" --without-flite --without-mikropuhe --without-theta --without-viavoice
make

directory="doc"
mkdir -p "${directory}"
for file in `find . \( -path "./${directory}" -o -path ./Documents \) -prune -o \( -name 'README*' -o -name '*.patch' -o -name '*.txt' -o -name '*.html' -o -name '*.sgml' -o \( -path "./Bootdisks/*" -type f -perm +ugo=x \) \) -print`
do
   mkdir -p "${directory}/${file%/*}"
   cp -rp "${file}" "${directory}/${file}"
done

%install
make install
install -m 644 Documents/brltty.conf "${RPM_BUILD_ROOT}%{_sysconfdir}"

%clean
rm -fr "${RPM_BUILD_ROOT}"

%files
%defattr(-,root,root)
%{_bindir}/brltty
%{_bindir}/brltty-*
%{_libdir}/brltty
%{_sysconfdir}/brltty
%doc %{_mandir}/man1/*
%doc Documents/Manual.sgml Documents/Manual.txt Documents/Manual-HTML
%doc COPYING
%doc Documents/ChangeLog Documents/TODO
%doc doc/*
%config(noreplace) %verify(not size md5 mtime) %{_sysconfdir}/brltty.conf

%files -n brlapi
%defattr(-,root,root)
%{_libdir}/libbrlapi.so.*
%doc Documents/BrlAPI.sgml Documents/BrlAPI.txt Documents/BrlAPI-HTML
%doc Documents/README.Gnopernicus

%files -n brlapi-devel
%defattr(-,root,root)
%{_libdir}/libbrlapi.a
%{_libdir}/libbrlapi.so
%{_includedir}/brltty
%doc %{_mandir}/man3/*
%doc Documents/BrlAPIref-HTML

%pre
# The pre-install scriptlet.

# If a configuration file already exists then rpm installs the new one as
# <path>.rpmnew. If this is done then the .rpmnew file is overwritten if it
# already exists.

# There's no explicit way to tell if a configuration file has been installed
# as itself or as a .rpmnew file. The way we'll figure it out, therefore, is by
# erasing the .rpmnew file now so that we can see if it gets created later. 
rm -f "%{_sysconfdir}/brltty.conf.rpmnew"

%post
# The post-install scriptlet.

# If BRLTTY's boot parameter has been specified then update the just installed
# configuration file template to reflect the options supplied thereby.

# First, we need to determine which file to update. If there's a .rpmnew file
# then update it since a previous configuration file must already have existed.
file="%{_sysconfdir}/brltty.conf"
new="${file}.rpmnew"
[ -f "${new}" ] && file="${new}"

# Update the configuration file template via the Bootdisks/bp2cf script.
# Include it right within this scriptlet so that it needn't be installed.
# Imbed it within a subshell to ensure that it won't impact this scriptlet.
(
   # First, set bp2cf's command line arguments.
   set -- -u -f "${file}"

   # Now run it by simply imbedding it right here.
   
#!/bin/sh
###############################################################################
# BRLTTY - A background process providing access to the Linux console (when in
#          text mode) for a blind person using a refreshable braille display.
#
# Copyright (C) 1995-2003 by The BRLTTY Team. All rights reserved.
#
# BRLTTY comes with ABSOLUTELY NO WARRANTY.
#
# This is free software, placed under the terms of the
# GNU General Public License, as published by the Free Software
# Foundation.  Please see the file COPYING for details.
#
# Web Page: http://mielke.cc/brltty/
#
# This software is maintained by Dave Mielke <dave@mielke.cc>.
###############################################################################

# Convert the boot parameter to configuration file directives.
# If /proc is mounted then use the brltty= boot parameter in /proc/cmdline.
# If /proc is not mounted then use the brltty environment variable.
# Invoke with -h for usage information.

programName="${0##*/}"
programMessage()
{
   echo 2>&1 "${programName}: ${1}"
}
syntaxError()
{
   programMessage "${1}"
   exit 2
}
internalError()
{
   programMessage "${1}"
   exit 3
}

configurationFile=""
requestedAction=create
deviceTranslation=none
requestedParameter=""
OPTIND=1
while getopts ":f:cundop:h" option
do
   case "${option}"
   in
      f) configurationFile="${OPTARG}";;
      c) requestedAction=create;;
      u) requestedAction=update;;
      n) deviceTranslation=none;;
      d) deviceTranslation=devfs;;
      o) deviceTranslation=old;;
      p) requestedParameter="${OPTARG}";;
      h)
         cat <<EOF
Usage: ${programName} [option ...]
-f file  The configuration file to create/update.
-c       Create the configuration file (write to stdout if no -f).
-u       Update the configuration file (copying from stdin to stdout if no -f).
-n       Do not translate device paths.
-d       Do old-style to devfs device path translation.
-o       Do devfs to old-style device path translation.
-p [driver][,[device][,[table]]]
         Explicitly specify the boot parameter.
-h       Display this usage summary.
EOF
         exit 0
         ;;
     \?) syntaxError "unknown option: -${OPTARG}";;
      :) syntaxError "missing value: -${OPTARG}";;
      *) internalError "unimplemented option: -${option}";;
   esac
done
shift "`expr $OPTIND - 1`"
[ "${#}" -eq 0 ] || syntaxError "too many parameters."

case "${requestedAction}"
in
   create)
      putConfigurationLine()
      {
         echo "${1}" || exit 4
      }
      startConfigurationFile()
      {
         [ -n "${configurationFile}" ] && exec >"${configurationFile}"
         putConfigurationLine "`makeHeaderLine Created`"
         putConfigurationLine "`makeParameterLine`"
         putConfigurationLine ""
      }
      putConfigurationDirective()
      {
         putConfigurationLine "${1} ${2}"
      }
      finalizeConfigurationFile()
      {
         :
      }
      ;;
   update)
      putSedCommand()
      {
         sedScript="${sedScript}
${1}"
      }
      startConfigurationFile()
      {
         if [ -n "${configurationFile}" ]
         then
            [ -e "${configurationFile}" ] || syntaxError "file not found: ${configurationFile}"
            [ -f "${configurationFile}" ] || syntaxError "not a file: ${configurationFile}"
            [ -r "${configurationFile}" ] || syntaxError "file not readable: ${configurationFile}"
            [ -w "${configurationFile}" ] || syntaxError "file not writable: ${configurationFile}"
            outputFile="${configurationFile}.new"
            exec <"${configurationFile}" >"${outputFile}"
         fi
         sedScript=""
         putSedCommand "1i\\
`makeHeaderLine Updated`\\
`makeParameterLine`\\
"
      }
      putConfigurationDirective()
      {
         value="`echo "${2}" | sed -e 's%\\([/\\]\\)%\\\\\\1%g'`"
         putSedCommand "/^ *#\\(${1} .*\\)/s//\\1/"
         putSedCommand "/^ *\\(${1}\\) .*/s//\\1 ${value}/"
      }
      finalizeConfigurationFile()
      {
         sed -e "${sedScript}"
         [ -n "${outputFile}" ] && mv -f "${outputFile}" "${configurationFile}"
      }
      ;;
   *) internalError "unimplemented action: ${requestedAction}";;
esac

translateDevice_none()
{
   :
}
translateDevice_devfs()
{
   minor="${device#ttyS}"
   if [ "${minor}" != "${device}" ]
   then
      device="tts/${minor}"
      return 0
   fi
   minor="${device#lp}"
   if [ "${minor}" != "${device}" ]
   then
      device="printers/${minor}"
      return 0
   fi
   programMessage "unsupported old-style device: ${device}"
}
translateDevice_old()
{
   major="${device%%/*}" 
   if [ "${major}" != "${device}" ]
   then
      minor="${device#*/}"
      case "${major}"
      in
         tts) devfs="ttyS${minor}";;
         printers) devfs="lp${minor}";;
      esac
   fi
   if [ -n "${devfs}" ]
   then
      device="${devfs}"
   else
      programMessage "unsupported devfs device: ${device}"
   fi
}

makeHeaderLine()
{
   echo "# ${1} by brltty-bp2cf`date +' on %Y-%m-%d at %H:%M:%S %Z (UTC%z)'`."
}
makeParameterLine()
{
   echo "# Boot Parameter:${bootParameter}"
}
putConfigurationFile()
{
   startConfigurationFile
   [ -n "${brailleDriver}" ] && putConfigurationDirective "braille-driver" "${brailleDriver}"
   [ -n "${brailleDevice}" ] && {
      device="`echo "${brailleDevice}" | sed -e 's%//*%/%g' -e 's%^/dev/%%'`"
      if [ "${device#/}" = "${device}" ]
      then
         translateDevice_${deviceTranslation}
      fi
      putConfigurationDirective "braille-device" "${device}"
   }
   [ -n "${textTable}" ] && putConfigurationDirective "text-table" "${textTable}"
   finalizeConfigurationFile
}
parseBootParameter()
{
   bootParameter="${bootParameter} ${1}"
   number=1
   while [ "${number}" -le 3 ]
   do
      cut="cut -d, -f${number}"
      [ "${number}" -gt 1 ] && cut="${cut} -s"
      operand="`echo ${1} | ${cut}`"
      if [ -n "${operand}" ]
      then
         case "${number}"
         in
            1) brailleDriver="${operand}";;
            2) brailleDevice="${operand}";;
            3) textTable="${operand}";;
         esac
      fi
      number="`expr ${number} + 1`"
   done
}
putBootParameter()
{
   parseBootParameter "${1}"
   putConfigurationFile
}
parseBootCommand()
{
   found=false
   while [ "${#}" -gt 0 ]
   do
      case "${1}"
      in
         "brltty="*)
            found=true
            parseBootParameter "${1#*=}"
            ;;
      esac
      shift
   done
   "${found}" && putConfigurationFile
}

brailleDriver=""
brailleDevice=""
textTable=""
bootCommandFile="/proc/cmdline"
if [ -n "${requestedParameter}" ]
then
   putBootParameter "${requestedParameter}"
elif [ -f "${bootCommandFile}" ]
then
   parseBootCommand `cat "${bootCommandFile}"`
elif [ -n "${brltty}" ]
then
   putBootParameter "${brltty}"
fi
exit 0
)

%changelog
* Mon Jun 12 2004 Dave Mielke <dave@mielke.cc> 3.5-1
+  BRLTTY 3.5 released:
-  Don't include the Mikropuhe speech driver in the RPM. (dm)
-  Fix up the lists of supported Papenmeier models. (dm)
-  Update brltty's LSM (Linux Software Map) for 3.5. (dm)
-  Documentation updates: (dm)
      Move the last section ("Epilogue") to the beginning (as "Formalities").
      Letter (rather than number) the appendices.
      Convert some descriptive lists into tables.
      Add some more alert tune events.
      Describe the Braille Firmness feature.
      Remove the mention of USB from the Voyager driver.
      Routing keys now function as a scroll bar for numeric preferences.
-  Document the speech FIFO: (dm)
      -F (--speech-fifo=) command line option
      speech-fifo configuration file directive
      BRLTTY_SPEECH_FIFO environment variable
-  Document the fact that identification by USB serial number may not work. (dm)
-  Restore the default status cell style for the HandyTech driver to "Alva". (dm)
-  Bring the change log up-to-date (3.4.1 to 3.5). (dm)
-  Only refer to libpthread if necessary. (dm)
+  BRLTTY 3.5pre4 released:
-  Increase the Voyager driver's STALL_TRIES setting from 3 to 7. (sd)
-  Split usbControlTransfer() into usbControlRead() and usbControlWrite(). (dm)
-  Add retry logic to the Voyager driver's call to usbBeginInput(). (dm)
-  The USB serial adapter handlers should return a boolean success value. (ml,dm)
-  gcc 3.3 reports "-lgcc_s not found" when linking statically. (dm)
-  Remove the BrailleLite driver's detection loop since the core now loops. (dm)
-  Disabling speech support breaks the compile. (ml)
-  Log the USB language. (dm)
-  Move the USB device open algorithm into the core. (dm)
-  Introcuce USB_IS_PRODUCT(). (ml,dm)
-  Remove unreachable code. (ml)
-  Repack the Freedom Scientific model entry structure. (ml)
-  Improve the way the null braille and speech drivers work. (dm)
-  Fix a pointer error. (st).
-  Most of the previous/next setting code is common. (dm)
-  Fix the comments for and adjust the names of the fields of the MenuItem structure. (dm)
-  Change the routing keys in the preferences menu from a set of descrete values to a scroll bar. (dm,np)
-  Fix a buffer overflow problem in updatePreferences(). (np,dm)
-  Building the BrlAPI reference manual fails when not building in the source tree. (ml)
-  Add the firmness handler to the Alva driver for the Satellite displays. (dm)
-  Prepare for reading USB input on systems which don't support URBs. (dm)
-  Get rid of the illegal type-punning warning. (dm)
-  Prepare the Papenmeier driver for protocol-specific handlers. (dm)
-  Support the HandyTech FTDI USB<->serial adapter. (ml)
-  Add a USB input packet filtering mechanism and use it for FTDI USB<->serial adapters. (dm)
-  Add the base for Papenmeier USB support. (ml,dm)
-  Parse contraction table input with unsignee chars. (dm)
-  Parse translation tables with unsigned chars. (dm)
-  Fix some problems with Solaris and HP-UX builds. (dm)
-  --with-screen-driver=no needs route.o. (dm)
-  Solaris and OpenBSD share the same PCM code. (dm)
-  Include sys_..._none.h files where appropriate. (dm)
-  Solaris requires -lsocket. (dm)
-  Linux, Solaris, OpenBSD, and FreeBSD all use <dlfcn.h>. (dm)
-  Linux and FreeBSD use the same PCM code. (dm)
-  Make BRLTTY buildable on FreeBSD. (dm)
-  Rename usbBulk(Read|Write)() to usb(Read|Write)Endpoint(). (dm)
-  Add USB support for OpenBSD (incomplete). (dm)
-  The Mikropuhe driver's deallocateSpeechItem() routine needs the new data argument. (dm)
-  EuroBraille update: (yp)
      More BrlAPI compliant.
      Update logged version number.
-  Include <unistd.h> within each header file which uses size_t. (sd)
-  Use message() to report TSI low battery condition. (sd)
-  Use a queue to link the pending USB input requests. (dm)
-  Some more tidying up of the USB declarations. (dm)
-  HandyTech display identification via USB was unreliable on a fast machine. (dm)
-  Maintain endpoint-specific data. (dm)
-  The preferences menu crashes if the contraction tables directory is bad. (dm)
-  The "er" in "surgery" doesn't get contracted (en-us-g2). (jb)
-  brl_readPacket() and brl_writePacket() now use the size_t and ssize_t types. (st)
-  Correct the BrlAPI client run-time discovery of libpthread use. (st)
-  BrlAPI fixes: (ml)
      Remove duplicate declarations already in pthread.h.
      strndup() is a glibc specific GNU extension which isn't available on some platforms, e.g. OpenBSD.
      "int vt" was declared outside the Linux specific block, causing a compiler warning about an unused variable.
-  brltty-install and brldefs.h didn't install correctly when not building in the source tree. (ml)
-  The Voyager driver should no longer be Linux-dependent. (ml)
-  Occasionally the rest of the line, rather than just the current word, becomes uncontracted. (dm)
-  Rearrange the public USB constants a bit. (dm)
-  Add the FTDI chip used by HandyTech. (ml)
-  Remove the reference to -lm. (dm)
-  Remove inclusion of <math.h>. (dm)
-  Change all doubles to floats. (np,dm)
-  Generate triangle (rather than sine) waves when playing tunes via the pcm. (np)
-  Implement the "Braille Firmness" preference. (dm)
-  Add "Braille Firmness" capability to the Voyager and FreedomScientific drivers. (dm)
-  Move usbBulk(Read|Write) out of the portable part of the USB core. (dm)
-  OpenBSD needs misc.c to include <sys/stat.yh>. (ml)
-  Ensure that all declarations are at the beginnings of their blocks. (ml)(
-  Remove double semicolons. (dm)
-  Add a "routing started" tune, change the "routing succeeded" tune. (sd)
-  Don't write the initial "application character map changed" log. (dm)
+  BRLTTY 3.5pre3 released:
-  Rename the key/cell offset/address variables in the Papenmeier driver. (dm)
-  Remove adlib debug logs. (dm)
-  Updates to the Papenmeier initialization debug logs. (dm)
-  Voyager driver changes: (dm)
      Remove failure on error for non-critical operations )the plus-box doesn't support them all).
      Call usbControlTranfer() with proper constants.
-  Rearrange parameters to usbControlTransfer(). (dm)
-  Add the $X suffix to the executables in the Papenmeier make file: (dm)
-  Papenmeier configuration file processing changes: (dm)
      Make parser errors more informative.
      Add more error checking.
-  Add support for rescue images to rhmkiso. (dm)
-  Preferences menu binding changes: (dm)
      The home/end keys are discard/exit.
      The escape/return keys are exit/save.
      The back command is previous setting.
-  Speed up the Papenmeier command resolution algorithm. (dm)
-  Papenmeier configuration file processing changes: (dm)
      Remove command and modifier table size limits.
      Allocate tables only as big as they need to be for each model.
      Allow processing to continue when an error is encountered.
-  Improve the Papenmeier help descriptions. (dm)
-  Tidy up the Papenmeier configuration file parser declarations. (dm)
-  Fix descrepancies in the Papenmeier status key toggle commands. (dm)
-  Remove the padding of help page widths to multiples of 40. (dm)
-  Allow a help page to have more than 255 lines. (dm)
-  Papenmeier driver changes: (dm)
      Remove the open retry loop.
      Improve some configuration file error messagds.
      Allow the key to be between or after the modifiers.
      List the key after, rather than before, the modifiers.
      Check for duplicate modifiers.
-  Report the use of a non-option argument when invoking brltty. (dm)
-  Log (debug) keys and commands in command learn mode. (dm)
-  Fix the learning of non-initial repeating commands. (dm)
-  Don't log Papenmeier non-modifier key releases. (dm)
-  Remove some double spaces within the Papenmeier configuration file. (dm)
-  Add a Papenmeier EL mode for the preferences menu. (dm)
-  Support the Papenmeier EL40 better as it has no right key. (dm)
-  Add the -a option to rhmkiso. (dm)
-  Change the rhmkiso image parameters into the -i and -o options. (dm)
-  Fix problems with HandyTech initialization after the loop was removed. (dm)
-  rhmkiso should look for the directory the same way isolinux does. (dm)
-  Add a README (README.RedHat.cd) for rhmkiso. (dm)
-  Rework the Papenmeier switch/key bindings. (dm)
-  Name the switches and keys correctly in the Papenmeier configuration file. (dm)
-  The short info display contains stray dots. (dm)
-  Remove the Televox driver. (np)
-  HandyTech driver changes: (dm)
      Check for errors after awaitInput().
      Only check for the display once when opening it.
-  awaitInput() should set EAGAIN on a timeout. (dm)
-  For BrlAPI: Remove the Vario driver's check that its internal buffer is being used. (mm)
-  Add forcePcmOutput() and awaitPcmOutput(). (dm)
-  Generate the dependencies before doing "make distclean". (dm)
-  Tidy up the Mikropuhe sample width setting code. (dm)
-  The Mikropuhe driver should close the sound device after a few seconds of inactivity. (dm)
-  The Mikropuhe mute function should stop the audio device immediately. (dm)
-  Mikropuhe driver enhancements: (dm)
      Synthesize and speak in a separate thread.
      Implement the mute function.
-  Core autorepeat support foiled leaving command learn mode for some displays. (dm)
-  Look for external packages in a few more places. (dm)
-  Rearrange code/declarations pertaining to command line options. (dm)
-  Add the speech pass-through FIFO. (np)
-  Don't call gettimeofday() if there's no rewrite interval. (np)
-  Use mallocWrapper() in the CombiBraille driver. (ml)
-  Fix the way in which the Alva driver calculates its rewrite interval. (dm)
-  Change the way the HandyTech driver detects timeouts. (dm)
-  Rewritten VisioBraille README. (sh)
-  Add the -t (built-in text table) option to rhmkiso. (np)
-  CMD_RETURN should behave just like CMD_HOME in the references menu. (np)
-  Add the displaysize= parameter to the VisioBraille driver. (sh)
-  big5 updates. (ck)
-  The English word "I" shouldn't have a letter sign in front of it. (dm)
-  Moved API authentication before any allocation or thread creation. (st)
-  Don't log an Alva display parameters packet as unexpected. (dm)
-  Set errno to EAGAIN if readChunk() times out. (dm)
-  Add usbAwaitInput(). (dm)
-  USB_DIR_(IN|OUT) have been renamed to USB_DIRECTION_(IN|OUT)PUT. (dm)
-  Make the settable ViaVoice rates and volumes more sensible. (dm)
-  Add serial adapter support to the USB core. (dm)
-  Allow --with-(text|attributes)-table= to take an absolute path. (dm)
-  Add USB support to the HandyTech driver. (ml)
-  Add the -s (start shell for inspection) option to rhmkiso. (dm)
-  Add rhmkiso command line argument parsing: (dm)
      A parameter to specify the original (input) image.
      A parameter to specify the modified (output) image.
      An option to specify the braille driver(s).
      An option to display command usage.
-  rhmkiso enhancements: (np)
      Copy the entire file structure rather than just the isolinux directory.
      Copy the volume and application identifiers.
      Create the destination image with Joliet support.
      Make it easier to configure a specific braille driver.
-  BrlAPI fixes: (stet
      Some blanks removed.
      brlapi_splitHost() now shared between server and client.
      Server now defaults to listening on local interface only for security.
      Read and write functions now return size_t.
      Read and write functions now define brlapi_errno themselves on error.
      brlapi_getTty() now returns the number of the tty it got.
-  Reverse the functions of the BrailleLite Millennium whiz wheels. (dm)
-  Rename mkrhiso to rhmkiso: (dm)
      Use nofb rather than video=vc:13.
      Strip the brltty executable before installing it.
      Don't invoke the interactive shell.
-  Implement the FreedomScientific (fs) braille driver. (dm)
-  Allow the USB input transfer mode to be specified. (dm)
+  BRLTTY 3.5pre2 released:
-  Bring device examples in brltty.conf template up-to-date. (dm)
-  Rework key bindings a bit for Alva 3nn and 4nn models. (np)
-  Add the RETURN command. (dm)
-  Add the prfword contraction table opcode. (dm)
-  BRLTTY Manual update: (np,dm)
      Remove documentation for tbl2hex and txt2hlp.
      Move "Contracted Braille" to its own top-level section.
      Some minor corrections.
-  More fixes to fr-abrege.ctb. (np)
-  Fix the "er" contraction in the French table. (np)
-  Add a script (mkrhiso) to make a RedHat/Fedora boot CD. (dm)
-  Single character contraction table matches should be case insensitive. (dm)
-  Give the "always" contraction table opcode a lower priority for matching. (dm)
-  Allow a contracted braille match string to contain spaces. (dm)
-  Fix the dependencies for the host_... objects. (np)
-  Add entries for the French words a, à, and y. (np)
+  BRLTTY 3.5pre1 released:
-  tbl2hex, tbltest and ctbtest should check for missing parameters. (np,dm)
-  Add text.brf.tbl. (np)
-  Fix the install-api-manpages make target to detect installation errors. (dm)
-  Add the fr-abrege contraction table. (np)
-  Add ctbtest. (dm)
-  Installing BRLTTY shouldn't require that BrlAPI's man pages be built. (dm)
-  Voyager driver enhancements: (sd)
      Remove internal support for autorepeat and use the core's facility.
      Add the brlinput= driver parameter.
-  Add the class, after and before contraction table opcodes. (dm)
-  Add the begmidword contraction table opcode. (dm)
-  Hard-code and logically group the contraction table opcode names. (dm)
-  Allow braille/speech driver parameters to be qualified with a driver identifier. (dm)
-  Add --with-(braille|speech|screen|api)-parameters=. (dm)
-  Add comment describing reason for selected dot-to-bit mapping. (np)
-  BrlAPI enhancements: (sh)
      brlapi_getDriverId and brlapi_getDriverName now use snprintf().
      Remove BRAPI_PACKETWRITE.
      Rewrite brlapi_writeBrl() to use the new extended write packet.
      Protocol version is now 2.
-  Enhance the description of the standard dot numbering convention. (dm)
-  Rename brlapi.h to api.h. (dm)
-  Document the --with-mikropuhe build option. (dm)
-  Correct the descriptions of the two supplied attributes translation tables. (dm)
-  Remove the documentation for tbl2tbl, tbl2txt, and txt2tbl. (dm)
-  BrlAPI enhancements: (sh)
      Protocol:
         Add protocol version to the authentication packet.
         Add extra server-side verifications to recognize a packet containing a
            valid authentication key but no protocol version (an old-style packet),
            and to report an accurate error message in this situation.
      api_server.c:
         Lower-case first letter of function names to be closer to core's coding style.
         Make all private fuoctions static.
-  VisioBraille driver enhancements: (sh)
      Add support for typing upper-case c with cedilla and upper-case a with grave.
      Key combinations of the form C-M-char can now be given from the braille keyboard.
      Code clean-up and instruction reordering.
      Add debug facilities for dealing with unknown PROMs.
-  Add tbltest. (dm)
-  BrlAPI enhancements: (sh)
      Add more explanation to comments for fields of brlapi_extWriteStruct.
      Check buffer size in brlapi_getDriverId() andbrlapi_getDriverName().
-  Add the fr-iso01 text translation table. (yp)
-  BrlAPI enhancements: (sh,st)
      brlapi_extWrite() now takes only one argument (of type brlapi_exjWriteStruct).
      BRLAPI_EXTWRITESTRUCT_INITIALIZER macro added (to initialize brlapi_extWriteStruct).
      Fields in packet and corresponding bits in flags have been reordered.
      Static variables inside client functions have been removed.
      brlapi_writeDots() now accepts "unsigned char"s (rather than "char"s).
      Return 0 and do nothing if region's begin exceeds its end.
      Server refuses invalid cursor position.
-  EuroBraille driver version 1.3.2. (yp)
-  Add a description to the VisioBraille text translation table. (sh)
-  Add Finnish text translation tables. (tm,dm)
-  Remove personal text translation tables. (dm)
-  The text/attributes translation tables are now editable text rather than binary. (np,dm)
-  ViaVoice driver enhancements: (dm)
      The speed= and volume= driver parameters are now handled by the preferences menu.
-  Add a skeleton setPcmAmplitudeFormat to the support for each non-Linux platform. (dm)
-  Add a table for uncontracted unified French braille. (np)
-  Introduce the user-space Voyager driver. (sd)
-  Map the Alva Satellite's tumbler keys. (dm)
-  Add the cursorDots() function. (sh,dm)
-  Add the extended write feature to BrlAPI. (sh)
-  Automatically turn off the Alva Satellite's PROG key simulation. (dm)
-  Add a routing succeeded tune. (sd)
-  Implement the Mikropuhe speech driver. (dm)
-  Normalize the tune names. (dm)
-  Fix the cursor routing timeout logic. (dm)
-  Play a tune when routing fails. (dm)
-  brlapi.h documentation enhancements: (sh)
      Correct the example for brlapi_initializeConnection().
      Illustrate the use of brlapi_strerror().
-  Tidy up the cursor routing code. (dm)
-  Clear all pending pids when a single SIGCHLD is received. (dm)
-  Modularize the status cell setting code. (dm)
-  Always recheck the VGA character count. (dm)
-  Fix ifdef placement errors for disabling speech support. (dm)
-  Don't install the API's man pages when API is disabled. (dm)
-  Configure's option summary output should be subject to the --quiet flag. (dm)
-  Include inttypes rather than stdint. (dm)
-  Add core-supported output overflow protection to Alva serial output. (dm)
-  Add support for the BrailleLite M20. (dm)
-  Increment BrlAPI's version number from 0.1.2 to 0.2.0. (dm)
-  Add -pipe to the gcc/g++ compile options. (dm)
-  BrlAPI fixes: (st)
      Get rid of bindings, 4k freed from the library.
      Remove brlapi_getControllingTty availability (getTty does it).
      Add support for WINDOWID (for multiplexer when an application is running in an xterm).
      "uint32_t" -> "int" for cursor (to allow -1 special value).
      "unsigned char"s for writeBrlDots().
      Add brlapi_strerror().
      A small but important fix in brlapi_errno_location().
      Rename BRLAPI_AUTHNAME to BRLAPI_AUTHPATH.
-  Document the BrailleNote key combination for command learn mode. (dm)
-  Add autorepeat to the Papenmeier driver. (dm)
-  Group the Papenmeier status keys more uniformly and conveniently. (dm)
-  Add the CMD_AUTOREPEAT command. (dm)
-  Don't include savePreferences if --disable-preferences-menu is specified. (dm)
-  When in learn mode write "lrn" to the status cells. (dm)
-  When in the preferences menu write "prf" rather than "prefs" to the status cells. (dm)
-  Enhance autospeak to respond to user input and cursor motion. (dm)
-  The mute functions of the FestivalLite and Theta drivers should wait till resources are freed. (dm)
-  Say speech rate/volume changes as they are made. (dm)
-  FestivalLite driver: replace wpm= with spk_rate(). (dm)
-  Theta driver: replace rate= with spk_rate(). (dm)
-  Add the Speech Volume preference. (dm)
-  Add the CMD_SAY_SOFTER and CMD_SAY_LOUDER commands. (dm)
-  Add spk_volume() to the Theta driver. (dm)
-  Fix key bindings for speech commands for PB80. (sd)
-  Add spk_rate() to the Festival driver. (dm)
-  Add the CMD_SAY_SLOWER and CMD_SAY_FASTER commands. (dm)
-  Add "Speech Rate" to the preferences menu. (dm)
-  BrlAPI fixes: (sh)
      Add braces to clarify an ambiguous else clause.
      Call the driver's reset() handler when raw mode is left improperly.
-  Correct the representation of 0XC7 (uppercase C with cedilla). (sh)
-  Remove the spurious #define of PREFSTYLE for the null braille driver. (dm)
-  brl_reset() should return a boolean. (dm)
-  EuroBraille driver version 1.3.2: (yp)
      Remade brl_ReadPacket and brl_WritePacket to allow writting of low-level packets and error code retrieving.
      Full Iris support.
      Implement brl_reset.
-  Move the autorepeat settings from command line options to the preferences menu. (dm)
-  Convert blinking settings from update intervals to elapsed time. (dm)
-  Command learn mode shouldn't announce CMD_NOOP. (dm)
-  Centralize the knowledge of which commands can autorepeat. (dm)
-  Clean up the toggle code. (dm)
-  big5 enhancements (including Nemeth Codes). (ck)
-  The mode pointer in the virtual driver shouldn't be externally visible. (dm)
-  Log each command as soon as it's received from the driver. (dm)
-  Log unrecognized and truncated Alva input packets. (dm)
-  Ensure that all toggle descriptions are formatted correctly for learn mode. (dm)
-  Rename the "VAL_SWITCH..." constants to "VAL_TOGGLE_...". (dm)
-  Change the HandyTech driver to use the core's autorepeat facility. (dm)
-  Log the compilation date and time for each driver. (dm)
-  Change all drivers to recognize qualified devices (serial:, usb:, client:, server:). (dm)
-  BRLTTY command-line options changes: (dm)
      Rename -R (--refresh-interval=) to -U (--update-interval=).
      Add -R (--autorepeat-delay=).
      Add -r (--autorepeat-interval=).
-  Change the Alva driver to use the core's autorepeat support. (dm)
-  Add autorepeat suport to the core. (dm)
-  Alvas automatically send an identification packet when DTR is ascerted. (dm)
-  Arbitrarily rewrite the Alva display whenever a configuration change occurs. (dm)
-  Log unexpected Alva input packets. (dm)
-  Alva Satellites can change dimensions on-the-fly. (dm)
-  Force the default choice when an invalid choice is made. (dm)
-  Reidentify an Alva display without restarting the driver. (dm)
-  Define front and top key bindings for the Alva Satellite models. (dm)
-  Define the alternate Alva routing and status keys. (dm)
-  Add USB support to the Alva driver. (dm)
-  Add USB support to the core. (dm)
-  Implement the Albatross driver. (dm)
-  Change the copyright end year from 2003 to 2004. (dm)

